/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.asgteach.capitalpunishment.model;

import java.util.Comparator;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;

/**
 *
 * @author gail
 */
public class Quiz {

    public static final int QUIZTOTAL = 5;

    private final IntegerProperty score = new SimpleIntegerProperty(0);
    private final IntegerProperty questionsAsked = 
            new SimpleIntegerProperty(0);
    private final Set<Integer> usedCountries = new HashSet<>();
    private final Random rand = new Random();
    private final Comparator<? super Country> capitalComparator;

    public int getQuestionsAsked() {
        return questionsAsked.get();
    }

    public IntegerProperty questionsAskedProperty() {
        return questionsAsked;
    }

    public int getScore() {
        return score.get();
    }

    public IntegerProperty scoreProperty() {
        return score;
    }
    
    public void doRightAnswer() {
        score.set(score.get() + 1);
        questionsAsked.set(questionsAsked.get() + 1);
    }
    
    public void doWrongAnswer() {
        questionsAsked.set(questionsAsked.get() + 1);
    }

    public Quiz() {
        capitalComparator = (Country c1, Country c2) -> {
            // Compare capital name for sorting
            return c1.getCapital().compareToIgnoreCase(c2.getCapital());
        };
    }

    public Question getNextQuestion() {
        Set<Integer> choicesArray = new HashSet<>();
        ObservableList<Country> capitals = 
                FXCollections.observableArrayList();
        SortedList<Country> sortedCaps = 
                new SortedList<>(capitals, capitalComparator);

        int nextCountryIndex = 
                rand.nextInt(WorldCountries.countryList.size());
        while (!usedCountries.add(nextCountryIndex)) {
            System.out.println("duplicate in used countries: " + 
                    nextCountryIndex);
            nextCountryIndex = rand.nextInt(
                    WorldCountries.countryList.size());
        }
        System.out.println("Found new target country: "
                + WorldCountries.countryList.get(
                    nextCountryIndex).getName()
                        + " (" + nextCountryIndex + ")");
        // Add it to the choices array, capitals array
        choicesArray.add(nextCountryIndex);
        capitals.add(WorldCountries.countryList.get(nextCountryIndex));
        System.out.println("Here is the answer: "
                + WorldCountries.countryList.get(
                        nextCountryIndex).getCapital());

        // Now fill choices array
        for (int i = 0; i < 4; i++) {
            int choice = rand.nextInt(WorldCountries.countryList.size());
            // make sure  country hasn't already been the target country
            while (usedCountries.contains(choice) || 
                    !choicesArray.add(choice)) {
                System.out.println("Failed choice = " + choice);
                choice = rand.nextInt(WorldCountries.countryList.size());
            }
            // now add it to the choices list
            System.out.println("Found a choice: "
                    + WorldCountries.countryList.get(choice).getCapital());
            capitals.add(WorldCountries.countryList.get(choice));
        }

        Question question
                = new Question(sortedCaps, 
                        WorldCountries.countryList.get(nextCountryIndex));
        return question;
    }

    public void resetQuiz() {
        usedCountries.clear();
        score.set(0);
        questionsAsked.set(0);
    }

}
